#' Nitrous oxide source isotopic signatures of nitrification, bacterial denitrification and fungal denitrification.
#'
#' @name n2o_sources
#' @docType data
#' @references L. Yu, E. Harris, D. Lewicka-Szczebak, et al., “What can we learn from N2O isotope data? – analytics, processes and modelling,” Rapid Communications in Mass Spectrometry, vol. 34, no. 20, Aug. 2020. \url{https://doi.org/10.1002/rcm.8858}
NULL

#' Nitrous oxide fractionation effect for reduction.
#'
#' @name n2o_frac
#' @docType data
#' @references L. Yu, E. Harris, D. Lewicka-Szczebak, et al., “What can we learn from N2O isotope data? – analytics, processes and modelling,” Rapid Communications in Mass Spectrometry, vol. 34, no. 20, Aug. 2020. \url{https://doi.org/10.1002/rcm.8858}
NULL

#' Simulated data of nitrous oxide isotopic measurements \eqn{\delta^{15}}N, \eqn{\delta^{15}}N$\eqn{^{SP}}, \eqn{\delta^{18}}O generated assuming contributions from nitrification, bacterial denitrification and fungal denitrification in addition to reduction.
#'
#' @name n2o_test
#' @docType data
NULL

#' Simulated data of nitrous oxide isotopic measurements \eqn{\delta^{15}}N, \eqn{\delta^{15}}N$\eqn{^{SP}} assuming contributions from nitrification and bacterial denitrification in addition to fractionation.
#'
#' @name n2o_test2
#' @docType data
NULL

#' Fixed weights `f1`, `f2`, `f3` and `r` used to simulate the data set `n2o_test`.
#'
#' @name n2o_weights
#' @docType data
NULL

#' Fixed weights `f1`, `f2` and `r` used to simulate the data set `n2o_test2`.
#'
#' @name n2o_weights2
#' @docType data
NULL
