// Generated by rstantools.  Do not edit by hand.

/*
    TimeFRAME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TimeFRAME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TimeFRAME.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_gp2_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_gp2");
    reader.add_event(57, 55, "end", "model_gp2");
    return reader;
}
#include <stan_meta_header.hpp>
class model_gp2
  : public stan::model::model_base_crtp<model_gp2> {
private:
        int d;
        int N;
        int K;
        int L;
        matrix_d b;
        matrix_d frac;
        std::vector<double> t;
        matrix_d X;
        matrix_d X_sd;
        double sigma;
        double rho;
        matrix_d X_vars;
        matrix_d X_means;
        matrix_d G;
        std::vector<matrix_d> LL;
        std::vector<vector_d> means2;
        std::vector<matrix_d> covs1;
        std::vector<matrix_d> covs2;
public:
    model_gp2(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_gp2(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_gp2_namespace::model_gp2";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 2;
            context__.validate_dims("data initialization", "d", "int", context__.to_vec());
            d = int(0);
            vals_i__ = context__.vals_i("d");
            pos__ = 0;
            d = vals_i__[pos__++];
            check_greater_or_equal(function__, "d", d, 1);
            current_statement_begin__ = 3;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            check_greater_or_equal(function__, "N", N, 1);
            current_statement_begin__ = 4;
            context__.validate_dims("data initialization", "K", "int", context__.to_vec());
            K = int(0);
            vals_i__ = context__.vals_i("K");
            pos__ = 0;
            K = vals_i__[pos__++];
            check_greater_or_equal(function__, "K", K, 1);
            current_statement_begin__ = 5;
            context__.validate_dims("data initialization", "L", "int", context__.to_vec());
            L = int(0);
            vals_i__ = context__.vals_i("L");
            pos__ = 0;
            L = vals_i__[pos__++];
            check_greater_or_equal(function__, "L", L, 0);
            current_statement_begin__ = 6;
            validate_non_negative_index("b", "(2 * d)", (2 * d));
            validate_non_negative_index("b", "K", K);
            context__.validate_dims("data initialization", "b", "matrix_d", context__.to_vec((2 * d),K));
            b = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>((2 * d), K);
            vals_r__ = context__.vals_r("b");
            pos__ = 0;
            size_t b_j_2_max__ = K;
            size_t b_j_1_max__ = (2 * d);
            for (size_t j_2__ = 0; j_2__ < b_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < b_j_1_max__; ++j_1__) {
                    b(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 7;
            validate_non_negative_index("frac", "(logical_gt(L, 0) ? (2 * d) : 0 )", (logical_gt(L, 0) ? (2 * d) : 0 ));
            validate_non_negative_index("frac", "L", L);
            context__.validate_dims("data initialization", "frac", "matrix_d", context__.to_vec((logical_gt(L, 0) ? (2 * d) : 0 ),L));
            frac = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>((logical_gt(L, 0) ? (2 * d) : 0 ), L);
            vals_r__ = context__.vals_r("frac");
            pos__ = 0;
            size_t frac_j_2_max__ = L;
            size_t frac_j_1_max__ = (logical_gt(L, 0) ? (2 * d) : 0 );
            for (size_t j_2__ = 0; j_2__ < frac_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < frac_j_1_max__; ++j_1__) {
                    frac(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 8;
            validate_non_negative_index("t", "N", N);
            context__.validate_dims("data initialization", "t", "double", context__.to_vec(N));
            t = std::vector<double>(N, double(0));
            vals_r__ = context__.vals_r("t");
            pos__ = 0;
            size_t t_k_0_max__ = N;
            for (size_t k_0__ = 0; k_0__ < t_k_0_max__; ++k_0__) {
                t[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 9;
            validate_non_negative_index("X", "d", d);
            validate_non_negative_index("X", "N", N);
            context__.validate_dims("data initialization", "X", "matrix_d", context__.to_vec(d,N));
            X = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, N);
            vals_r__ = context__.vals_r("X");
            pos__ = 0;
            size_t X_j_2_max__ = N;
            size_t X_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < X_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_j_1_max__; ++j_1__) {
                    X(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 10;
            validate_non_negative_index("X_sd", "d", d);
            validate_non_negative_index("X_sd", "N", N);
            context__.validate_dims("data initialization", "X_sd", "matrix_d", context__.to_vec(d,N));
            X_sd = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, N);
            vals_r__ = context__.vals_r("X_sd");
            pos__ = 0;
            size_t X_sd_j_2_max__ = N;
            size_t X_sd_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < X_sd_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_sd_j_1_max__; ++j_1__) {
                    X_sd(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 11;
            context__.validate_dims("data initialization", "sigma", "double", context__.to_vec());
            sigma = double(0);
            vals_r__ = context__.vals_r("sigma");
            pos__ = 0;
            sigma = vals_r__[pos__++];
            check_greater_or_equal(function__, "sigma", sigma, 0);
            current_statement_begin__ = 12;
            context__.validate_dims("data initialization", "rho", "double", context__.to_vec());
            rho = double(0);
            vals_r__ = context__.vals_r("rho");
            pos__ = 0;
            rho = vals_r__[pos__++];
            check_greater_or_equal(function__, "rho", rho, 0);
            // initialize transformed data variables
            current_statement_begin__ = 15;
            validate_non_negative_index("X_vars", "d", d);
            validate_non_negative_index("X_vars", "N", N);
            X_vars = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, N);
            stan::math::fill(X_vars, DUMMY_VAR__);
            stan::math::assign(X_vars,divide(add(square(X_sd), square(sigma)), 2));
            current_statement_begin__ = 16;
            validate_non_negative_index("X_means", "d", d);
            validate_non_negative_index("X_means", "N", N);
            X_means = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, N);
            stan::math::fill(X_means, DUMMY_VAR__);
            current_statement_begin__ = 17;
            validate_non_negative_index("G", "N", N);
            validate_non_negative_index("G", "N", N);
            G = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N);
            stan::math::fill(G, DUMMY_VAR__);
            stan::math::assign(G,gp_exp_quad_cov(t, 1.0, rho));
            current_statement_begin__ = 18;
            validate_non_negative_index("LL", "N", N);
            validate_non_negative_index("LL", "N", N);
            validate_non_negative_index("LL", "d", d);
            LL = std::vector<Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> >(d, Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N));
            stan::math::fill(LL, DUMMY_VAR__);
            current_statement_begin__ = 19;
            validate_non_negative_index("means2", "N", N);
            validate_non_negative_index("means2", "d", d);
            means2 = std::vector<Eigen::Matrix<double, Eigen::Dynamic, 1> >(d, Eigen::Matrix<double, Eigen::Dynamic, 1>(N));
            stan::math::fill(means2, DUMMY_VAR__);
            current_statement_begin__ = 20;
            validate_non_negative_index("covs1", "N", N);
            validate_non_negative_index("covs1", "N", N);
            validate_non_negative_index("covs1", "d", d);
            covs1 = std::vector<Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> >(d, Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N));
            stan::math::fill(covs1, DUMMY_VAR__);
            current_statement_begin__ = 21;
            validate_non_negative_index("covs2", "N", N);
            validate_non_negative_index("covs2", "N", N);
            validate_non_negative_index("covs2", "d", d);
            covs2 = std::vector<Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> >(d, Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N));
            stan::math::fill(covs2, DUMMY_VAR__);
            // execute transformed data statements
            current_statement_begin__ = 23;
            for (int i = 1; i <= d; ++i) {
                current_statement_begin__ = 23;
                stan::model::assign(X_means, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            rep_row_vector(mean(get_base1(X, i, "X", 1)), N), 
                            "assigning variable X_means");
            }
            current_statement_begin__ = 24;
            for (int i = 1; i <= N; ++i) {
                current_statement_begin__ = 24;
                stan::model::assign(G, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), 
                            (stan::model::rvalue(G, stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "G") + 1e-9), 
                            "assigning variable G");
            }
            current_statement_begin__ = 25;
            for (int i = 1; i <= d; ++i) {
                current_statement_begin__ = 26;
                stan::model::assign(LL, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            cholesky_decompose(add_diag(multiply(variance(get_base1(X, i, "X", 1)), G), get_base1(X_vars, i, "X_vars", 1))), 
                            "assigning variable LL");
                current_statement_begin__ = 27;
                stan::model::assign(means2, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            mdivide_left_tri_low(get_base1(LL, i, "LL", 1), transpose(get_base1(X_means, i, "X_means", 1))), 
                            "assigning variable means2");
                current_statement_begin__ = 28;
                stan::model::assign(covs1, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            mdivide_left_tri_low(get_base1(LL, i, "LL", 1), diag_matrix(transpose(get_base1(X_vars, i, "X_vars", 1)))), 
                            "assigning variable covs1");
                current_statement_begin__ = 29;
                stan::model::assign(covs2, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            mdivide_left_tri_low(get_base1(LL, i, "LL", 1), multiply(variance(get_base1(X, i, "X", 1)), G)), 
                            "assigning variable covs2");
            }
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 33;
            validate_non_negative_index("f", "K", K);
            validate_non_negative_index("f", "N", N);
            num_params_r__ += ((K - 1) * N);
            current_statement_begin__ = 34;
            validate_non_negative_index("r", "L", L);
            validate_non_negative_index("r", "N", N);
            num_params_r__ += (L * N);
            current_statement_begin__ = 35;
            validate_non_negative_index("baux", "d", d);
            validate_non_negative_index("baux", "K", K);
            num_params_r__ += (d * K);
            current_statement_begin__ = 36;
            validate_non_negative_index("A", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
            validate_non_negative_index("A", "L", L);
            num_params_r__ += ((logical_gt(L, 0) ? d : 0 ) * L);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_gp2() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 33;
        if (!(context__.contains_r("f")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable f missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("f");
        pos__ = 0U;
        validate_non_negative_index("f", "K", K);
        validate_non_negative_index("f", "N", N);
        context__.validate_dims("parameter initialization", "f", "vector_d", context__.to_vec(N,K));
        std::vector<Eigen::Matrix<double, Eigen::Dynamic, 1> > f(N, Eigen::Matrix<double, Eigen::Dynamic, 1>(K));
        size_t f_j_1_max__ = K;
        size_t f_k_0_max__ = N;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < f_k_0_max__; ++k_0__) {
                f[k_0__](j_1__) = vals_r__[pos__++];
            }
        }
        size_t f_i_0_max__ = N;
        for (size_t i_0__ = 0; i_0__ < f_i_0_max__; ++i_0__) {
            try {
                writer__.simplex_unconstrain(f[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable f: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        current_statement_begin__ = 34;
        if (!(context__.contains_r("r")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable r missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("r");
        pos__ = 0U;
        validate_non_negative_index("r", "L", L);
        validate_non_negative_index("r", "N", N);
        context__.validate_dims("parameter initialization", "r", "matrix_d", context__.to_vec(L,N));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> r(L, N);
        size_t r_j_2_max__ = N;
        size_t r_j_1_max__ = L;
        for (size_t j_2__ = 0; j_2__ < r_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
                r(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_lub_unconstrain(0, 1, r);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable r: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 35;
        if (!(context__.contains_r("baux")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable baux missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("baux");
        pos__ = 0U;
        validate_non_negative_index("baux", "d", d);
        validate_non_negative_index("baux", "K", K);
        context__.validate_dims("parameter initialization", "baux", "matrix_d", context__.to_vec(d,K));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> baux(d, K);
        size_t baux_j_2_max__ = K;
        size_t baux_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < baux_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < baux_j_1_max__; ++j_1__) {
                baux(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_lub_unconstrain(-(0.5), 0.5, baux);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable baux: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 36;
        if (!(context__.contains_r("A")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable A missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("A");
        pos__ = 0U;
        validate_non_negative_index("A", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
        validate_non_negative_index("A", "L", L);
        context__.validate_dims("parameter initialization", "A", "matrix_d", context__.to_vec((logical_gt(L, 0) ? d : 0 ),L));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> A((logical_gt(L, 0) ? d : 0 ), L);
        size_t A_j_2_max__ = L;
        size_t A_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < A_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < A_j_1_max__; ++j_1__) {
                A(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(A);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable A: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 33;
            std::vector<Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> > f;
            size_t f_d_0_max__ = N;
            f.reserve(f_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < f_d_0_max__; ++d_0__) {
                if (jacobian__)
                    f.push_back(in__.simplex_constrain(K, lp__));
                else
                    f.push_back(in__.simplex_constrain(K));
            }
            current_statement_begin__ = 34;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> r;
            (void) r;  // dummy to suppress unused var warning
            if (jacobian__)
                r = in__.matrix_lub_constrain(0, 1, L, N, lp__);
            else
                r = in__.matrix_lub_constrain(0, 1, L, N);
            current_statement_begin__ = 35;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> baux;
            (void) baux;  // dummy to suppress unused var warning
            if (jacobian__)
                baux = in__.matrix_lub_constrain(-(0.5), 0.5, d, K, lp__);
            else
                baux = in__.matrix_lub_constrain(-(0.5), 0.5, d, K);
            current_statement_begin__ = 36;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> A;
            (void) A;  // dummy to suppress unused var warning
            if (jacobian__)
                A = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), L, lp__);
            else
                A = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), L);
            // transformed parameters
            current_statement_begin__ = 39;
            validate_non_negative_index("S", "d", d);
            validate_non_negative_index("S", "K", K);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> S(d, K);
            stan::math::initialize(S, DUMMY_VAR__);
            stan::math::fill(S, DUMMY_VAR__);
            current_statement_begin__ = 40;
            validate_non_negative_index("mu", "d", d);
            validate_non_negative_index("mu", "N", N);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> mu(d, N);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            // transformed parameters block statements
            current_statement_begin__ = 42;
            stan::math::assign(S, add(stan::model::rvalue(b, stan::model::cons_list(stan::model::index_min_max(1, d), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "b"), elt_multiply(baux, stan::model::rvalue(b, stan::model::cons_list(stan::model::index_min_max((d + 1), (2 * d)), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "b"))));
            current_statement_begin__ = 43;
            for (int i = 1; i <= N; ++i) {
                current_statement_begin__ = 43;
                stan::model::assign(mu, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), 
                            multiply(S, get_base1(f, i, "f", 1)), 
                            "assigning variable mu");
            }
            current_statement_begin__ = 44;
            if (as_bool(logical_gt(L, 0))) {
                current_statement_begin__ = 44;
                stan::math::assign(mu, add(mu, multiply(A, stan::math::log(r))));
            }
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 39;
            size_t S_j_1_max__ = d;
            size_t S_j_2_max__ = K;
            for (size_t j_1__ = 0; j_1__ < S_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < S_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(S(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: S" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable S: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 40;
            size_t mu_j_1_max__ = d;
            size_t mu_j_2_max__ = N;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(mu(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: mu" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable mu: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            // model body
            {
            current_statement_begin__ = 47;
            validate_non_negative_index("mean1", "N", N);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> mean1(N);
            stan::math::initialize(mean1, DUMMY_VAR__);
            stan::math::fill(mean1, DUMMY_VAR__);
            current_statement_begin__ = 49;
            for (int l = 1; l <= L; ++l) {
                current_statement_begin__ = 49;
                lp_accum__.add(normal_log(stan::model::rvalue(A, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(l), stan::model::nil_index_list())), "A"), stan::model::rvalue(frac, stan::model::cons_list(stan::model::index_min_max(1, d), stan::model::cons_list(stan::model::index_uni(l), stan::model::nil_index_list())), "frac"), stan::model::rvalue(frac, stan::model::cons_list(stan::model::index_min_max((d + 1), (2 * d)), stan::model::cons_list(stan::model::index_uni(l), stan::model::nil_index_list())), "frac")));
            }
            current_statement_begin__ = 50;
            for (int i = 1; i <= d; ++i) {
                current_statement_begin__ = 51;
                stan::math::assign(mean1, mdivide_left_tri_low(get_base1(LL, i, "LL", 1), transpose(get_base1(mu, i, "mu", 1))));
                current_statement_begin__ = 52;
                lp_accum__.add(multi_normal_log(get_base1(X, i, "X", 1), add(multiply(transpose(get_base1(covs2, i, "covs2", 1)), mean1), multiply(transpose(get_base1(covs1, i, "covs1", 1)), get_base1(means2, i, "means2", 1))), add_diag(multiply(transpose(get_base1(covs1, i, "covs1", 1)), get_base1(covs2, i, "covs2", 1)), get_base1(X_vars, i, "X_vars", 1))));
                current_statement_begin__ = 53;
                lp_accum__.add(multi_normal_cholesky_log(get_base1(mu, i, "mu", 1), get_base1(X_means, i, "X_means", 1), get_base1(LL, i, "LL", 1)));
            }
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("f");
        names__.push_back("r");
        names__.push_back("baux");
        names__.push_back("A");
        names__.push_back("S");
        names__.push_back("mu");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(N);
        dims__.push_back(K);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(L);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(d);
        dims__.push_back(K);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((logical_gt(L, 0) ? d : 0 ));
        dims__.push_back(L);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(d);
        dims__.push_back(K);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(d);
        dims__.push_back(N);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_gp2_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        std::vector<Eigen::Matrix<double, Eigen::Dynamic, 1> > f;
        size_t f_d_0_max__ = N;
        f.reserve(f_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < f_d_0_max__; ++d_0__) {
            f.push_back(in__.simplex_constrain(K));
        }
        size_t f_j_1_max__ = K;
        size_t f_k_0_max__ = N;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < f_k_0_max__; ++k_0__) {
                vars__.push_back(f[k_0__](j_1__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> r = in__.matrix_lub_constrain(0, 1, L, N);
        size_t r_j_2_max__ = N;
        size_t r_j_1_max__ = L;
        for (size_t j_2__ = 0; j_2__ < r_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
                vars__.push_back(r(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> baux = in__.matrix_lub_constrain(-(0.5), 0.5, d, K);
        size_t baux_j_2_max__ = K;
        size_t baux_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < baux_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < baux_j_1_max__; ++j_1__) {
                vars__.push_back(baux(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> A = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), L);
        size_t A_j_2_max__ = L;
        size_t A_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < A_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < A_j_1_max__; ++j_1__) {
                vars__.push_back(A(j_1__, j_2__));
            }
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 39;
            validate_non_negative_index("S", "d", d);
            validate_non_negative_index("S", "K", K);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> S(d, K);
            stan::math::initialize(S, DUMMY_VAR__);
            stan::math::fill(S, DUMMY_VAR__);
            current_statement_begin__ = 40;
            validate_non_negative_index("mu", "d", d);
            validate_non_negative_index("mu", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> mu(d, N);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            // do transformed parameters statements
            current_statement_begin__ = 42;
            stan::math::assign(S, add(stan::model::rvalue(b, stan::model::cons_list(stan::model::index_min_max(1, d), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "b"), elt_multiply(baux, stan::model::rvalue(b, stan::model::cons_list(stan::model::index_min_max((d + 1), (2 * d)), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "b"))));
            current_statement_begin__ = 43;
            for (int i = 1; i <= N; ++i) {
                current_statement_begin__ = 43;
                stan::model::assign(mu, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), 
                            multiply(S, get_base1(f, i, "f", 1)), 
                            "assigning variable mu");
            }
            current_statement_begin__ = 44;
            if (as_bool(logical_gt(L, 0))) {
                current_statement_begin__ = 44;
                stan::math::assign(mu, add(mu, multiply(A, stan::math::log(r))));
            }
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t S_j_2_max__ = K;
                size_t S_j_1_max__ = d;
                for (size_t j_2__ = 0; j_2__ < S_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < S_j_1_max__; ++j_1__) {
                        vars__.push_back(S(j_1__, j_2__));
                    }
                }
                size_t mu_j_2_max__ = N;
                size_t mu_j_1_max__ = d;
                for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                        vars__.push_back(mu(j_1__, j_2__));
                    }
                }
            }
            if (!include_gqs__) return;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_gp2";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t f_j_1_max__ = K;
        size_t f_k_0_max__ = N;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < f_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "f" << '.' << k_0__ + 1 << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t r_j_2_max__ = N;
        size_t r_j_1_max__ = L;
        for (size_t j_2__ = 0; j_2__ < r_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "r" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t baux_j_2_max__ = K;
        size_t baux_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < baux_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < baux_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "baux" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t A_j_2_max__ = L;
        size_t A_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < A_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < A_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "A" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t S_j_2_max__ = K;
            size_t S_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < S_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < S_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "S" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_j_2_max__ = N;
            size_t mu_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t f_j_1_max__ = (K - 1);
        size_t f_k_0_max__ = N;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < f_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "f" << '.' << k_0__ + 1 << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t r_j_2_max__ = N;
        size_t r_j_1_max__ = L;
        for (size_t j_2__ = 0; j_2__ < r_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "r" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t baux_j_2_max__ = K;
        size_t baux_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < baux_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < baux_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "baux" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t A_j_2_max__ = L;
        size_t A_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < A_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < A_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "A" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t S_j_2_max__ = K;
            size_t S_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < S_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < S_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "S" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_j_2_max__ = N;
            size_t mu_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
    }
}; // model
}  // namespace
typedef model_gp2_namespace::model_gp2 stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
