// Generated by rstantools.  Do not edit by hand.

/*
    TimeFRAME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TimeFRAME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TimeFRAME.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_stationary_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_stationary");
    reader.add_event(29, 27, "end", "model_stationary");
    return reader;
}
#include <stan_meta_header.hpp>
class model_stationary
  : public stan::model::model_base_crtp<model_stationary> {
private:
        int d;
        int N;
        int K;
        int L;
        matrix_d x;
        matrix_d b;
        matrix_d sdev;
        vector_d sigma;
        matrix_d frac;
        matrix_d frac_sdev;
public:
    model_stationary(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_stationary(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_stationary_namespace::model_stationary";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 2;
            context__.validate_dims("data initialization", "d", "int", context__.to_vec());
            d = int(0);
            vals_i__ = context__.vals_i("d");
            pos__ = 0;
            d = vals_i__[pos__++];
            check_greater_or_equal(function__, "d", d, 1);
            current_statement_begin__ = 3;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            check_greater_or_equal(function__, "N", N, 1);
            current_statement_begin__ = 4;
            context__.validate_dims("data initialization", "K", "int", context__.to_vec());
            K = int(0);
            vals_i__ = context__.vals_i("K");
            pos__ = 0;
            K = vals_i__[pos__++];
            check_greater_or_equal(function__, "K", K, 1);
            current_statement_begin__ = 5;
            context__.validate_dims("data initialization", "L", "int", context__.to_vec());
            L = int(0);
            vals_i__ = context__.vals_i("L");
            pos__ = 0;
            L = vals_i__[pos__++];
            check_greater_or_equal(function__, "L", L, 0);
            current_statement_begin__ = 6;
            validate_non_negative_index("x", "d", d);
            validate_non_negative_index("x", "N", N);
            context__.validate_dims("data initialization", "x", "matrix_d", context__.to_vec(d,N));
            x = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, N);
            vals_r__ = context__.vals_r("x");
            pos__ = 0;
            size_t x_j_2_max__ = N;
            size_t x_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < x_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < x_j_1_max__; ++j_1__) {
                    x(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 7;
            validate_non_negative_index("b", "d", d);
            validate_non_negative_index("b", "K", K);
            context__.validate_dims("data initialization", "b", "matrix_d", context__.to_vec(d,K));
            b = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, K);
            vals_r__ = context__.vals_r("b");
            pos__ = 0;
            size_t b_j_2_max__ = K;
            size_t b_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < b_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < b_j_1_max__; ++j_1__) {
                    b(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 8;
            validate_non_negative_index("sdev", "d", d);
            validate_non_negative_index("sdev", "K", K);
            context__.validate_dims("data initialization", "sdev", "matrix_d", context__.to_vec(d,K));
            sdev = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(d, K);
            vals_r__ = context__.vals_r("sdev");
            pos__ = 0;
            size_t sdev_j_2_max__ = K;
            size_t sdev_j_1_max__ = d;
            for (size_t j_2__ = 0; j_2__ < sdev_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < sdev_j_1_max__; ++j_1__) {
                    sdev(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 9;
            validate_non_negative_index("sigma", "d", d);
            context__.validate_dims("data initialization", "sigma", "vector_d", context__.to_vec(d));
            sigma = Eigen::Matrix<double, Eigen::Dynamic, 1>(d);
            vals_r__ = context__.vals_r("sigma");
            pos__ = 0;
            size_t sigma_j_1_max__ = d;
            for (size_t j_1__ = 0; j_1__ < sigma_j_1_max__; ++j_1__) {
                sigma(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 10;
            validate_non_negative_index("frac", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
            validate_non_negative_index("frac", "(logical_gt(L, 0) ? L : 0 )", (logical_gt(L, 0) ? L : 0 ));
            context__.validate_dims("data initialization", "frac", "matrix_d", context__.to_vec((logical_gt(L, 0) ? d : 0 ),(logical_gt(L, 0) ? L : 0 )));
            frac = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ));
            vals_r__ = context__.vals_r("frac");
            pos__ = 0;
            size_t frac_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
            size_t frac_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
            for (size_t j_2__ = 0; j_2__ < frac_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < frac_j_1_max__; ++j_1__) {
                    frac(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 11;
            validate_non_negative_index("frac_sdev", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
            validate_non_negative_index("frac_sdev", "(logical_gt(L, 0) ? L : 0 )", (logical_gt(L, 0) ? L : 0 ));
            context__.validate_dims("data initialization", "frac_sdev", "matrix_d", context__.to_vec((logical_gt(L, 0) ? d : 0 ),(logical_gt(L, 0) ? L : 0 )));
            frac_sdev = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ));
            vals_r__ = context__.vals_r("frac_sdev");
            pos__ = 0;
            size_t frac_sdev_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
            size_t frac_sdev_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
            for (size_t j_2__ = 0; j_2__ < frac_sdev_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < frac_sdev_j_1_max__; ++j_1__) {
                    frac_sdev(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            // initialize transformed data variables
            // execute transformed data statements
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 14;
            validate_non_negative_index("f", "K", K);
            num_params_r__ += (K - 1);
            current_statement_begin__ = 15;
            validate_non_negative_index("r", "L", L);
            num_params_r__ += L;
            current_statement_begin__ = 16;
            validate_non_negative_index("s", "d", d);
            validate_non_negative_index("s", "K", K);
            num_params_r__ += (d * K);
            current_statement_begin__ = 17;
            validate_non_negative_index("a", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
            validate_non_negative_index("a", "(logical_gt(L, 0) ? L : 0 )", (logical_gt(L, 0) ? L : 0 ));
            num_params_r__ += ((logical_gt(L, 0) ? d : 0 ) * (logical_gt(L, 0) ? L : 0 ));
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_stationary() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 14;
        if (!(context__.contains_r("f")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable f missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("f");
        pos__ = 0U;
        validate_non_negative_index("f", "K", K);
        context__.validate_dims("parameter initialization", "f", "vector_d", context__.to_vec(K));
        Eigen::Matrix<double, Eigen::Dynamic, 1> f(K);
        size_t f_j_1_max__ = K;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            f(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.simplex_unconstrain(f);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable f: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 15;
        if (!(context__.contains_r("r")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable r missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("r");
        pos__ = 0U;
        validate_non_negative_index("r", "L", L);
        context__.validate_dims("parameter initialization", "r", "vector_d", context__.to_vec(L));
        Eigen::Matrix<double, Eigen::Dynamic, 1> r(L);
        size_t r_j_1_max__ = L;
        for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
            r(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lub_unconstrain(0, 1, r);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable r: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 16;
        if (!(context__.contains_r("s")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable s missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("s");
        pos__ = 0U;
        validate_non_negative_index("s", "d", d);
        validate_non_negative_index("s", "K", K);
        context__.validate_dims("parameter initialization", "s", "matrix_d", context__.to_vec(d,K));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> s(d, K);
        size_t s_j_2_max__ = K;
        size_t s_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < s_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
                s(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_lub_unconstrain(-(0.5), 0.5, s);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable s: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 17;
        if (!(context__.contains_r("a")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable a missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("a");
        pos__ = 0U;
        validate_non_negative_index("a", "(logical_gt(L, 0) ? d : 0 )", (logical_gt(L, 0) ? d : 0 ));
        validate_non_negative_index("a", "(logical_gt(L, 0) ? L : 0 )", (logical_gt(L, 0) ? L : 0 ));
        context__.validate_dims("parameter initialization", "a", "matrix_d", context__.to_vec((logical_gt(L, 0) ? d : 0 ),(logical_gt(L, 0) ? L : 0 )));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> a((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ));
        size_t a_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
        size_t a_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < a_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < a_j_1_max__; ++j_1__) {
                a(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(a);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable a: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 14;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> f;
            (void) f;  // dummy to suppress unused var warning
            if (jacobian__)
                f = in__.simplex_constrain(K, lp__);
            else
                f = in__.simplex_constrain(K);
            current_statement_begin__ = 15;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> r;
            (void) r;  // dummy to suppress unused var warning
            if (jacobian__)
                r = in__.vector_lub_constrain(0, 1, L, lp__);
            else
                r = in__.vector_lub_constrain(0, 1, L);
            current_statement_begin__ = 16;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> s;
            (void) s;  // dummy to suppress unused var warning
            if (jacobian__)
                s = in__.matrix_lub_constrain(-(0.5), 0.5, d, K, lp__);
            else
                s = in__.matrix_lub_constrain(-(0.5), 0.5, d, K);
            current_statement_begin__ = 17;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> a;
            (void) a;  // dummy to suppress unused var warning
            if (jacobian__)
                a = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ), lp__);
            else
                a = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ));
            // transformed parameters
            current_statement_begin__ = 20;
            validate_non_negative_index("mu", "d", d);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> mu(d);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            // transformed parameters block statements
            current_statement_begin__ = 21;
            stan::math::assign(mu, multiply(add(b, elt_multiply(s, sdev)), f));
            current_statement_begin__ = 22;
            if (as_bool(logical_gt(L, 0))) {
                current_statement_begin__ = 22;
                stan::math::assign(mu, add(mu, multiply(a, stan::math::log(r))));
            }
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 20;
            size_t mu_j_1_max__ = d;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(mu(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: mu" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable mu: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            // model body
            current_statement_begin__ = 25;
            if (as_bool(logical_gt(L, 0))) {
                current_statement_begin__ = 25;
                for (int i = 1; i <= d; ++i) {
                    current_statement_begin__ = 25;
                    lp_accum__.add(normal_log<propto__>(get_base1(a, i, "a", 1), get_base1(frac, i, "frac", 1), get_base1(frac_sdev, i, "frac_sdev", 1)));
                }
            }
            current_statement_begin__ = 26;
            for (int i = 1; i <= d; ++i) {
                current_statement_begin__ = 26;
                lp_accum__.add(normal_log<propto__>(get_base1(x, i, "x", 1), get_base1(mu, i, "mu", 1), get_base1(sigma, i, "sigma", 1)));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("f");
        names__.push_back("r");
        names__.push_back("s");
        names__.push_back("a");
        names__.push_back("mu");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(K);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(L);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(d);
        dims__.push_back(K);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((logical_gt(L, 0) ? d : 0 ));
        dims__.push_back((logical_gt(L, 0) ? L : 0 ));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(d);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_stationary_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        Eigen::Matrix<double, Eigen::Dynamic, 1> f = in__.simplex_constrain(K);
        size_t f_j_1_max__ = K;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            vars__.push_back(f(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> r = in__.vector_lub_constrain(0, 1, L);
        size_t r_j_1_max__ = L;
        for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
            vars__.push_back(r(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> s = in__.matrix_lub_constrain(-(0.5), 0.5, d, K);
        size_t s_j_2_max__ = K;
        size_t s_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < s_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
                vars__.push_back(s(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> a = in__.matrix_constrain((logical_gt(L, 0) ? d : 0 ), (logical_gt(L, 0) ? L : 0 ));
        size_t a_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
        size_t a_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < a_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < a_j_1_max__; ++j_1__) {
                vars__.push_back(a(j_1__, j_2__));
            }
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 20;
            validate_non_negative_index("mu", "d", d);
            Eigen::Matrix<double, Eigen::Dynamic, 1> mu(d);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            // do transformed parameters statements
            current_statement_begin__ = 21;
            stan::math::assign(mu, multiply(add(b, elt_multiply(s, sdev)), f));
            current_statement_begin__ = 22;
            if (as_bool(logical_gt(L, 0))) {
                current_statement_begin__ = 22;
                stan::math::assign(mu, add(mu, multiply(a, stan::math::log(r))));
            }
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t mu_j_1_max__ = d;
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    vars__.push_back(mu(j_1__));
                }
            }
            if (!include_gqs__) return;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_stationary";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t f_j_1_max__ = K;
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "f" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t r_j_1_max__ = L;
        for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "r" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t s_j_2_max__ = K;
        size_t s_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < s_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "s" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t a_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
        size_t a_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < a_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < a_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "a" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t mu_j_1_max__ = d;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t f_j_1_max__ = (K - 1);
        for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "f" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t r_j_1_max__ = L;
        for (size_t j_1__ = 0; j_1__ < r_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "r" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t s_j_2_max__ = K;
        size_t s_j_1_max__ = d;
        for (size_t j_2__ = 0; j_2__ < s_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "s" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t a_j_2_max__ = (logical_gt(L, 0) ? L : 0 );
        size_t a_j_1_max__ = (logical_gt(L, 0) ? d : 0 );
        for (size_t j_2__ = 0; j_2__ < a_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < a_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "a" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t mu_j_1_max__ = d;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
    }
}; // model
}  // namespace
typedef model_stationary_namespace::model_stationary stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
