test_that("Independent model works", {
  d <- data.frame(X = c(5,0), Y = c(0, 5), DX = c(1,1), DY = c(1,1), row.names = c("A", "B"))
  m <- frame_model(d)
  x <- data.frame(x = c(0.9, 1, 0.8), y = c(0.1, 0.3, 0.1))
  sd <- x + 2
  testthat::expect_error(fit <- fit_frame(m, x, eta = 0))
  testthat::expect_no_error(fit <- fit_frame(m, x, eta = 1))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd, eta = 1))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, eta = c(1,1)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd, eta = c(1,1)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
})

test_that("Independent model works with fractionation", {
  d <- data.frame(X = c(5,0), Y = c(0, 5), DX = c(1,1), DY = c(1,1), row.names = c("A", "B"))
  f <- data.frame(X = c(-1), Y = c(-1), sX = c(1), sY = c(1), row.names = c("F"))
  m <- frame_model(d, frac = f)
  x <- data.frame(x = c(0.9, 1, 0.8), y = c(0.1, 0.3, 0.1))
  sd <- x + 1
  testthat::expect_error(fit <- fit_frame(m, x, eta = 0))
  testthat::expect_no_error(fit <- fit_frame(m, x, eta = 1))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd, eta = 1))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, eta = c(1,1)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_frame(m, x, sd = sd, eta = c(1,1)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
})
