test_that("Stationary model works", {
  m <- frame_model(matrix(c(5,0,0,5,1,1,1,1), ncol = 4))
  x <- data.frame(x = c(0.9, 1, 0.8), y = c(0.1, 0.3, 0.1))
  testthat::expect_no_error(fit <- fit_stationary(m, x, eta = 1))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_stationary(m, x, eta = c(1,1)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
})

test_that("Stationary model works with fractionation", {
  m <- frame_model(matrix(c(5,0,0,5,1,1,1,1), ncol = 4), frac = matrix(c(-1,-1,1,1), ncol = 4))
  x <- data.frame(x = c(0.9, 1, 0.8), y = c(0.1, 0.3, 0.1))
  testthat::expect_no_error(fit <- fit_stationary(m, x, eta = 2))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
  testthat::expect_no_error(fit <- fit_stationary(m, x, eta = c(2,2)))
  testthat::expect_vector(coef(fit, point.est = "mean"))
  testthat::expect_vector(coef(fit, point.est = "median"))
  testthat::expect_vector(as.data.frame(fit))
})
